package com.sa.ibiz.demo.demoapp.controller.demo;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.sql.Timestamp;
import javax.annotation.Resource;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.Data;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import com.sa.ibiz.demo.ibizutil.domain.ActionResult;
import com.sa.ibiz.demo.demo.service.UserRoleDataService;
import com.sa.ibiz.demo.ibizutil.domain.AutoCompleteItem;
import com.sa.ibiz.demo.demo.domain.UserRoleData;
import com.sa.ibiz.demo.demo.service.dto.UserRoleDataSearchFilter;
import com.sa.ibiz.demo.demoapp.controller.demo.vo.*;
import org.springframework.cglib.beans.BeanGenerator;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.util.StringUtils;
import java.io.IOException;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.validation.annotation.Validated;
import org.springframework.http.ResponseEntity;
import org.springframework.beans.factory.annotation.Autowired;
import com.sa.ibiz.demo.ibizutil.domain.RedirectResult;
import javax.validation.constraints.NotBlank;
import com.sa.ibiz.demo.ibizutil.domain.AutoCompleteItem;
import java.math.BigInteger;
import com.alibaba.fastjson.JSONObject;

@RestController
@RequestMapping("/demoapp/demo/userroledata")
public class UserRoleDataController{



    @Autowired
	private UserRoleDataService userroledataService;
	/**
	 * 获取服务对象
	*/
	protected UserRoleDataService getService(){
		return this.userroledataService;
	}



	@PostMapping(value="maineditform/update")
	public ResponseEntity<UserRoleData_EditForm_Main> mainEditFormUpdate(@Validated @RequestBody UserRoleData_EditForm_Main form){
            UserRoleData entity =form.toUserRoleData();
            getService().update(entity);
            form.fromUserRoleData(entity);
            form.setSrfuf("1");
            return ResponseEntity.ok().body(form);
	}
	@GetMapping(value="maineditform/remove")
	public ResponseEntity<UserRoleData_EditForm_Main> mainEditFormRemove(@Validated @NotBlank(message = "srfkey不允许为空") @RequestParam("srfkey")String srfkey){
            UserRoleData_EditForm_Main form=new UserRoleData_EditForm_Main();
            UserRoleData entity = new UserRoleData();
            entity.setUserroledataid(srfkey);
            getService().remove(entity);
            form.setSrfuf("0");
            form.fromUserRoleData(entity);
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="maineditform/getdraft")
	public ResponseEntity<UserRoleData_EditForm_Main> mainEditFormGetDraft(@RequestBody UserRoleData_EditForm_Main form){
        if(!StringUtils.isEmpty(form.getSrfsourcekey()))
        {
            UserRoleData sourceEntity =new UserRoleData();
            sourceEntity.setUserroledataid(form.getSrfsourcekey());
            this.getService().get(sourceEntity);

			UserRoleData targetEntity =new UserRoleData();
			sourceEntity.copyTo(targetEntity);
			form.fromUserRoleData(targetEntity,false);
            form.setSrfuf("0");
            return ResponseEntity.ok().body(form);
         }
            UserRoleData entity =form.toUserRoleData();
            getService().getDraft(entity);
            form.fromUserRoleData(entity);
            form.setSrfuf("0");
            return ResponseEntity.ok().body(form);
	}
	@GetMapping(value="maineditform/get")
	public ResponseEntity<UserRoleData_EditForm_Main> mainEditFormGet(@Validated @NotBlank(message = "srfkey不允许为空") @RequestParam("srfkey")String srfkey){
            UserRoleData_EditForm_Main form=new UserRoleData_EditForm_Main();
            UserRoleData entity = new UserRoleData();
            entity.setUserroledataid(srfkey);
            entity=getService().get(entity);
            form.setSrfuf("1");
            form.fromUserRoleData(entity);
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="maineditform/create")
	public ResponseEntity<UserRoleData_EditForm_Main> mainEditFormCreate(@Validated @RequestBody UserRoleData_EditForm_Main form){
            UserRoleData entity =form.toUserRoleData();
            getService().create(entity);
            form.fromUserRoleData(entity);
            form.setSrfuf("1");
            return ResponseEntity.ok().body(form);
	}
	@Autowired
	private com.sa.ibiz.demo.demo.service.DataEntityService dataentityService;
	@PostMapping(value="maineditform/dename/ac")
	public ResponseEntity<List<AutoCompleteItem>> mainEditForm_dename_ac(@RequestBody UserRoleData_EditForm_Main form){
		List<AutoCompleteItem> list =new ArrayList<>();
		com.sa.ibiz.demo.demo.service.dto.DataEntitySearchFilter searchFilter = new com.sa.ibiz.demo.demo.service.dto.DataEntitySearchFilter();
		UserRoleData entity =form.toUserRoleData();
		String queryField=entity.getDename();
		searchFilter.getSelectCond().like("dename",queryField);
		Page<com.sa.ibiz.demo.demo.domain.DataEntity> searchResult = dataentityService.searchDefault(searchFilter);
		for(com.sa.ibiz.demo.demo.domain.DataEntity entity2 :searchResult.getRecords()) {
			AutoCompleteItem acItem =new AutoCompleteItem();
			acItem.setValue(entity2.getDeid());
			acItem.setText(entity2.getDename());
			acItem.setRealtext(entity2.getDename());
			list.add(acItem);
			}
		return ResponseEntity.ok().body(list);
	}
	@Autowired
	private com.sa.ibiz.demo.demo.service.OrgService orgService;
	@PostMapping(value="maineditform/dstorgname/ac")
	public ResponseEntity<List<AutoCompleteItem>> mainEditForm_dstorgname_ac(@RequestBody UserRoleData_EditForm_Main form){
		List<AutoCompleteItem> list =new ArrayList<>();
		com.sa.ibiz.demo.demo.service.dto.OrgSearchFilter searchFilter = new com.sa.ibiz.demo.demo.service.dto.OrgSearchFilter();
		UserRoleData entity =form.toUserRoleData();
		String queryField=entity.getDstorgname();
		searchFilter.getSelectCond().like("orgname",queryField);
		Page<com.sa.ibiz.demo.demo.domain.Org> searchResult = orgService.searchDefault(searchFilter);
		for(com.sa.ibiz.demo.demo.domain.Org entity2 :searchResult.getRecords()) {
			AutoCompleteItem acItem =new AutoCompleteItem();
			acItem.setValue(entity2.getOrgid());
			acItem.setText(entity2.getOrgname());
			acItem.setRealtext(entity2.getOrgname());
			list.add(acItem);
			}
		return ResponseEntity.ok().body(list);
	}
	@Autowired
	private com.sa.ibiz.demo.demo.service.OrgSectorService orgsectorService;
	@PostMapping(value="maineditform/dstorgsectorname/ac")
	public ResponseEntity<List<AutoCompleteItem>> mainEditForm_dstorgsectorname_ac(@RequestBody UserRoleData_EditForm_Main form){
		List<AutoCompleteItem> list =new ArrayList<>();
		com.sa.ibiz.demo.demo.service.dto.OrgSectorSearchFilter searchFilter = new com.sa.ibiz.demo.demo.service.dto.OrgSectorSearchFilter();
		UserRoleData entity =form.toUserRoleData();
		String queryField=entity.getDstorgsectorname();
		searchFilter.getSelectCond().like("orgsectorname",queryField);
		Page<com.sa.ibiz.demo.demo.domain.OrgSector> searchResult = orgsectorService.searchDefault(searchFilter);
		for(com.sa.ibiz.demo.demo.domain.OrgSector entity2 :searchResult.getRecords()) {
			AutoCompleteItem acItem =new AutoCompleteItem();
			acItem.setValue(entity2.getOrgsectorid());
			acItem.setText(entity2.getOrgsectorname());
			acItem.setRealtext(entity2.getOrgsectorname());
			list.add(acItem);
			}
		return ResponseEntity.ok().body(list);
	}
	@PostMapping(value="maingrid/update")
	public UserRoleData mainGridUpdate(@Validated UserRoleData mainItem){
		return mainItem;
	}
	@PostMapping(value="maingrid/remove")
	public ResponseEntity<UserRoleData> mainGridRemove(@Validated @RequestBody Map args){
	    UserRoleData entity =new UserRoleData();
	    if ( !StringUtils.isEmpty(args.get("srfkeys"))) {
			String srfkeys=args.get("srfkeys").toString();
			String srfkeyArr[] =srfkeys.split(";");
			for(String srfkey : srfkeyArr)
			{
				if(!StringUtils.isEmpty(srfkey)){
				entity.setUserroledataid(srfkey);
				this.getService().remove(entity);
                }
            }
        }
		return ResponseEntity.ok().body(entity);
	}
	public UserRoleData mainGridGet(String userroledataid){
		return null;
	}
	@PostMapping(value="maingrid/getdraft")
	public UserRoleData mainGridGetDraft(@Validated UserRoleData mainItem){
		return mainItem;
	}
	@PostMapping(value="maingrid/create")
	public UserRoleData mainGridCreate(@Validated UserRoleData mainItem){
		return mainItem;
	}
	@org.springframework.beans.factory.annotation.Value("${ibiz.filePath}")
    private String strFilePath;
	@Autowired
    private com.sa.ibiz.demo.ibizutil.service.IBZFILEService ibzfileService;
	/**
	 * [main]表格数据导出
	 * @param searchFilter
	 * @return
	 * @throws
	 * @throws
	 */
	@PostMapping(value="maingrid/exportdata/searchdefault")
	public ResponseEntity<Page<JSONObject>> maingridExportDataSearchDefault(@Validated @RequestBody UserRoleDataSearchFilter searchFilter) throws IOException, jxl.write.WriteException {
		String fileid=com.baomidou.mybatisplus.core.toolkit.IdWorker.get32UUID();
		String localPath=ExportDataInit(fileid);//输出文件相对路径
		Page<UserRoleData> searchResult = this.getService().searchDefault(searchFilter);//1.查询表格数据
		List<Map<String,Object>> datas=UserRoleData_Grid_Main.pageToListDatas(searchResult);//2.将数据转换成list
		List<Map<String,String>> colnums=UserRoleData_Grid_Main.getGridColumnModels();//3.获取表格列头
        java.io.File outputFile=com.sa.ibiz.demo.ibizutil.helper.DEDataExportHelper.output(strFilePath+localPath,colnums,datas);//4.生成导出文件
		com.sa.ibiz.demo.ibizutil.helper.DEDataExportHelper.saveFileData(outputFile,localPath,fileid,ibzfileService); //5.保存file表记录
		String strDownloadUrl =String.format("ibizutil/download/"+fileid);//6.回传文件路径给前台
        Page<JSONObject> resultObj=UserRoleData_Grid_Main.getResultPage(searchResult,strDownloadUrl);//7.获取输出对象
			return ResponseEntity.ok().body(resultObj);
	}
	/**
	 * 表格数据导出
	 * @param fileid
	 * @return
	 */
	private String ExportDataInit(String fileid) {
		java.text.SimpleDateFormat dateFormat = new java.text.SimpleDateFormat("yyyyMMdd");
        String filepath=dateFormat.format(new java.util.Date())+ java.io.File.separator;
        java.text.SimpleDateFormat dateFormat2 = new java.text.SimpleDateFormat("yyyyMMddHHmmss");
		String strTempFileName = fileid+"-"+dateFormat2.format(new java.util.Date())+".xls";
		java.io.File file =new java.io.File(strFilePath+filepath);
		if(!file.exists())
           file.mkdirs();
		return filepath+strTempFileName;
	}
	@PostMapping(value="maingrid/searchdefault")
	public ResponseEntity<Page<UserRoleData_Grid_Main>> mainGridSearchDefault(@Validated @RequestBody UserRoleDataSearchFilter searchFilter){
			Page<UserRoleData> searchResult = this.getService().searchDefault(searchFilter);
			Page<UserRoleData_Grid_Main> searchResult_vo_data =UserRoleData_Grid_Main.fromUserRoleData(searchResult);
					return ResponseEntity.ok().body(searchResult_vo_data);
	}
	@PostMapping(value="defaultsearchform/load")
	public void defaultSearchFormLoad(){

	}
   	@PostMapping(value="defaultsearchform/loaddraft")
	public ResponseEntity<UserRoleData_SearchForm_Default> defaultSearchFormLoadDraft(@Validated @RequestBody UserRoleData_SearchForm_Default searchform){
 		 
			UserRoleDataSearchFilter searchfilter =searchform.toUserRoleDataSearchFilter();
			searchform.fromUserRoleDataSearchFilter(searchfilter);
			return ResponseEntity.ok().body(searchform);
	} 
	@PostMapping(value="defaultsearchform/search")
	public void defaultSearchFormSearch(){
			 
	} 
 }